package com.sd.business.service.sku.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sd.business.entity.sku.dto.SkuDto;
import com.sd.business.entity.sku.dto.SkuSelectDto;
import com.sd.business.entity.sku.po.Sku;
import com.sd.business.entity.sku.vo.SkuVo;
import com.sd.business.mapper.sku.SkuMapper;
import com.sd.business.service.sku.SkuService;
import com.sd.framework.util.Assert;
import com.sd.framework.util.sql.Sql;
import org.springframework.stereotype.Service;


/**
 * <p>
 * sku 服务实现类
 * </p>
 *
 * @author
 * @since 2023-11-09
 */
@Service
public class SkuServiceImpl extends ServiceImpl<SkuMapper, Sku> implements SkuService {

    @Override
    public Page<SkuVo> getPage(SkuSelectDto dto) {

        Page<SkuVo> page = Sql.create(SkuVo.class)
                .selectAll(Sku.class)
                .from(Sku.class)
                .orderByDesc(Sku::getId)
                .page(dto.getPage());

        return page;
    }

    @Override
    public SkuVo detail(Long id) {

        SkuVo vo = Sql.create(SkuVo.class)
                .selectAll(Sku.class)
                .from(Sku.class)
                .eq(Sku::getId, id)
                .one();

        Assert.notNull(vo, "未知数据");

        return vo;
    }

    @Override
    public void add(SkuDto dto) {
        save(dto);
    }

    @Override
    public void edit(SkuDto dto) {
        updateById(dto);
    }

    @Override
    public void delete(Long id) {
        removeById(id);
    }

}
